#!/usr/bin/perl
#
#		LIDS Log 
#		by xie@lids.org
#		Released under GPL 
#		
#
use CGI;
use Mysql;

$page_item = 20;
$query = new CGI;

my $mydate="";
if($ARGV[0] ne "genindex" ) {
	print $query->header;
} else {
	$mydate = " Last updated: ".localtime();
}

$dbh = Mysql->connect($localhost, 'lids' , 'lidsadm', 'lids4fun')
                or die "Couldn't connect to database: " . Mysql->errstr;

my $num=0;
$next = $query->param('next');
if($next eq "") {$next=0;};

$order = $query->param('order');
$type= $query->param('type');

if($order eq "") {$order="date"};
$search = $query->param('search');

if($query->param('type') eq "host") {
	$host_checked = "CHECKED";
	search($search,'host',$order);
}elsif($query->param('type') eq "program") {
	$program_checked = "CHECKED";
	search($search,'program',$order);
}elsif($query->param('type') eq "reason") {
	$reason_checked = "CHECKED";
	search($search,'reason',$order);
}else {
	$host_checked = "CHECKED";
	search('','','date');
}

print <<E_O_F;

<html><title> LIDS Log </title> <center>
<link rel="stylesheet" href="/janus.css" type="text/css">

<body bgcolor="white">
<a href="/">
<img src="/icons/abc.gif">
</a>
<p>
<form NAME="lids_frm" METHOD="POST" ACTION="/cgi-bin/lids_web.pl" enctype="application/x-www-form-urlencoded">
<input type="hidden" name="order" value="host">
<input type="hidden" name="next" value="0">
<input TYPE="text" NAME="search" VALUE="$search" MAXLENGTH="50"> 
<input TYPE="Submit" NAME="Submit" VALUE="Search">
<font size=-1>
<input type="radio" name="type" value="host" $host_checked> Host 
<input type="radio" name="type" value="program" $program_checked> Program 
<input type="radio" name="type" value="reason" $reason_checked> Reason 
</font>
</form>
<br>
<table border=0>
<tr>
<td colspan=7 class=result>
Result from <b>$this_next </b> to <b>$to_next</b> in <font color=red>$total_num </font> records matched for search <font color=red>$search</font> order by $order 
&nbsp;&nbsp;
<font color=red>*</font><font size="-1">  means logs had been disable for 60s</font>
<tr><td>
<tr> 
<td  align=center class=header> 
<a href="?next=0&type=$type&order=date&search=$search">Date</a> 
<td align=center class=header> 
<a href="?next=0&type=$type&order=host&search=$search">Host</a> 
<td align=center class=header> 
<a href="?next=0&type=$type&order=program&search=$search">Program</a> 
<td  align=center class=header>
<a href="?next=0&type=$type&order=uid&search=$search"> uid/gid</a>
<td  align=center class=header>
<a href="?next=0&type=$type&order=pid&search=$search"> pid/ppid</a>
<td align=center class=header> 
<a href="?next=0&type=$type&order=reason&search=$search"> tty</a>
<td align=center class=header> Reason <tr> 

$rec

<tr><td>
<tr>
<td colspan=7>
<table width=100%><tr>
<td align=left>
<b>
<font size=-1>
<a href="?next=$prev&type=$type&order=$order&search=$search">[<<< Prev ]</a> 
</font>
</b>
<td align=right>
<b>
<font size=-1>
<a href="?next=$next&type=$type&order=$order&search=$search">[>>> Next ]</a> 
</font>
</b>
</table>
<tr> <td colspan=7>
<tr> <td colspan=7 class=desc>
[<a href="">Return to Home Page</a>]
&nbsp; &nbsp;
&nbsp; &nbsp;
$mydate
</table>

  <P ALIGN="CENTER">
  <A HREF="http://www.apache.org/"><IMG SRC="/icons/apache_pb.gif" ALT="[ Powered by Apache ]"></A>
  <A HREF="http://www.redhat.com/"><IMG SRC="/poweredby.png" ALT="[ Powered by Red Hat Linux ]"></A>
  <A HREF="http://www.perl.org/"><IMG SRC="/icons/perl.gif" ALT="[ Powered by PERL ]"></A>
  <A HREF="http://www.mysql.org/"><IMG SRC="/icons/mysql.png" ALT="[ Powered by MySQL]"></A>
  </P>
 </BODY>
</HTML>
</form>
</html>

E_O_F

sub search 
{
	$text = $_[0];
	$field = $_[1];
	$order = $_[2];
	my @search = split(/ /,$text);
	$dbquery = 'SELECT * FROM logs '; 
	$str="";
	$i = 0;
	if($text ne "") {
		$dbquery = $dbquery." where ";	
		foreach $word  (@search) {
			if($i>0) {
				$str = $str." AND ";
			}
			$str = $str." $field LIKE '\%$word\%'" ;
			$i++;
		}	 
	}
	if($order eq "cve") {
		if($i>0) {
			$str = $str." AND ";
		} else {
			$str = $str." where ";
		}
		$str = $str." cve not LIKE '\%NO\%' ";
	}
	$dbquery=$dbquery.$str." order by $order DESC";
	do_search($dbquery,$page_item);

	$this_prev=$prev;
	$this_next=$next;
	$prev = $next-$page_item;
	if($prev<0) {$prev =0};
	$next = $next+$page_item;
	if($next>$total_num) {$next=$next-$page_item; $to_next=$total_num}
	else { $to_next=$next;}
}

sub search_lids 
{
	 $dbquery = "SELECT * FROM logs Order by date DESC"; 
	
	do_search($dbquery,40);
}


sub do_search {

$query=$_[0];
$limit=$_[1];
my @data;
print "<!-- $query -->";
my $sth = $dbh->query($query)
            or die "Couldn't execute statement: " . $sth->errstr;
$total_num = $sth->rows;
$num=0;
if($limit == 0) { $limit = 1000; }

while (@data = $sth->fetchrow_array()) {
	my $host= $data[0];
	my $date = $data[1];
        my $program = $data[2];
        my $dev = $data[3];
	my $inode =$data[4];
	my $uid =$data[5];
	my $gid =$data[6];
	my $pid =$data[7];
	my $ppid =$data[8];
	my $tty=$data[9];
	my $reason = $data[10];

	$num++;
	if($num>$next+$limit) {last;}
	if($num<$next) {next;}
	if($num>$total_num) {last;}
	
	my @search = split(/\s+/,$search);
	
	foreach $search_str (@search) {
		$reason=~s/$search_str/<font color=\"green\">$search_str<\/font>/ig;
	}
	if($reason =~/- logging disable/) {
		$reason=$`."<font color=red> * </font>";
	}
	$cveurl="";
	
	$rec=$rec."<tr> <td class=email> $date".  
		"<td align=center class=email> $host".
		" <td align=center class=email><b> $program</b>".
		" <td align=center class=email> $uid/$gid".
		" <td align=center class=email> $pid/$ppid".
		" <td align=center class=email> $tty".
		" <td align=left class=desc> $reason\n";
}
}
